" echodoc
" set cmdheight=2
let g:echodoc#enable_at_startup = 1
let g:echodoc#type = 'signature'


" function! ConfigureCocNVIM()
" " ============ coc.nvim ===========
	" " if hidden is not set, TextEdit might fail.
	" set hidden

	" " Some servers have issues with backup files, see #649
	" set nobackup
	" set nowritebackup

	" " Better display for messages
	" "set cmdheight=2

	" " You will have bad experience for diagnostic messages when it's default 4000.
	" set updatetime=300

	" " don't give |ins-completion-menu| messages.
	" set shortmess+=c

	" " always show signcolumns
	" set signcolumn=yes

	" " Use tab for trigger completion with characters ahead and navigate.
	" " Use command ':verbose imap <tab>' to make sure tab is not mapped by other plugin.
	" inoremap <silent><expr> <TAB>
		  " \ pumvisible() ? "\<C-n>" :
		  " \ <SID>check_back_space() ? "\<TAB>" :
		  " \ coc#refresh()
	" inoremap <expr><S-TAB> pumvisible() ? "\<C-p>" : "\<C-h>"

	" function! s:check_back_space() abort
	  " let col = col('.') - 1
	  " return !col || getline('.')[col - 1]  =~# '\s'
	" endfunction

	" " Use <c-space> to trigger completion.
	" inoremap <silent><expr> <c-space> coc#refresh()

	" " Use <cr> to confirm completion, `<C-g>u` means break undo chain at current position.
	" " Coc only does snippet and additional edit on confirm.
	" inoremap <expr> <cr> pumvisible() ? "\<C-y>" : "\<C-g>u\<CR>"
	" " Or use `complete_info` if your vim support it, like:
	" " inoremap <expr> <cr> complete_info()["selected"] != "-1" ? "\<C-y>" : "\<C-g>u\<CR>"

	" " Use `[g` and `]g` to navigate diagnostics
	" nmap <silent> ,g <Plug>(coc-diagnostic-prev)
	" nmap <silent> .g <Plug>(coc-diagnostic-next)

	" " Remap keys for gotos
	" nmap <silent> gd <Plug>(coc-definition)
	" nmap <silent> gy <Plug>(coc-type-definition)
	" nmap <silent> gi <Plug>(coc-implementation)
	" nmap <silent> gr <Plug>(coc-references)

	" " Use K to show documentation in preview window
	" nnoremap <silent> K :call <SID>show_documentation()<CR>

	" function! s:show_documentation()
	  " if (index(['vim','help'], &filetype) >= 0)
		" execute 'h '.expand('<cword>')
	  " else
		" call CocActionAsync('doHover')
	  " endif
	" endfunction

	" " Highlight symbol under cursor on CursorHold
	" autocmd CursorHold * silent call CocActionAsync('highlight')

	" " Remap for rename current word
	" nmap <leader>rn <Plug>(coc-rename)

	" " Remap for format selected region
	" " xmap <leader>f  <Plug>(coc-format-selected)
	" " nmap <leader>f  <Plug>(coc-format-selected)

	" augroup mygroup
	  " autocmd!
	  " " Setup formatexpr specified filetype(s).
	  " autocmd FileType typescript,json setl formatexpr=CocAction('formatSelected')
	  " " Update signature help on jump placeholder
	  " autocmd User CocJumpPlaceholder call CocActionAsync('showSignatureHelp')
	" augroup end

	" " Remap for do codeAction of selected region, ex: `<leader>aap` for current paragraph
	" xmap <leader>a  <Plug>(coc-codeaction-selected)
	" nmap <leader>a  <Plug>(coc-codeaction-selected)

	" " Remap for do codeAction of current line
	" nmap <leader>ac  <Plug>(coc-codeaction)
	" " Fix autofix problem of current line
	" nmap <leader>qf  <Plug>(coc-fix-current)

	" " Create mappings for function text object, requires document symbols feature of languageserver.
	" xmap if <Plug>(coc-funcobj-i)
	" xmap af <Plug>(coc-funcobj-a)
	" omap if <Plug>(coc-funcobj-i)
	" omap af <Plug>(coc-funcobj-a)

	" " Use <TAB> for select selections ranges, needs server support, like: coc-tsserver, coc-python
	" nmap <silent> <TAB> <Plug>(coc-range-select)
	" xmap <silent> <TAB> <Plug>(coc-range-select)

	" " Use `:Format` to format current buffer
	" command! -nargs=0 Format :call CocAction('format')

	" " Use `:Fold` to fold current buffer
	" command! -nargs=? Fold :call     CocAction('fold', <f-args>)

	" " use `:OR` for organize import of current buffer
	" command! -nargs=0 OR   :call     CocAction('runCommand', 'editor.action.organizeImport')

	" " Add status line support, for integration with other plugin, checkout `:h coc-status`
	" set statusline^=%{coc#status()}%{get(b:,'coc_current_function','')}

	" " Using CocList
	" " Show all diagnostics
	" nnoremap <silent> .a        :<C-u>CocList diagnostics<cr>
	" " Manage extensions
	" nnoremap <silent> .e  :<C-u>CocList extensions<cr>
	" " Show commands
	" nnoremap <silent> <space>c  :<C-u>CocList commands<cr>
	" " Find symbol of current document
	" nnoremap <silent> .o  :<C-u>CocList outline<cr>
	" " Search workspace symbols
	" nnoremap <silent> <space>s  :<C-u>CocList -I symbols<cr>
	" " Do default action for next item.
	" nnoremap <silent> <space>j  :<C-u>CocNext<CR>
	" " Do default action for previous item.
	" nnoremap <silent> <space>k  :<C-u>CocPrev<CR>
	" " Resume latest coc list
	" nnoremap <silent> <space>p  :<C-u>CocListResume<CR>
" endfunction


" autocmd! User coc.nvim call ConfigureCocNVIM()

" function s:CocStop()
	" :CocDisable
	" call coc#rpc#start_server()
" endfunction

" command! -nargs=0 CocStop      :call s:CocStop()

"LanguageClient-neovim
" Required for operations modifying multiple buffers like rename.
set hidden

let g:LanguageClient_autoStart = 0
let g:LanguageClient_diagnosticsEnable = 1
let g:LanguageClient_diagnosticsList = "Quickfix"
let g:LanguageClient_diagnosticsDisplay = {
        \ 1: {
        \     "name": "Error",
        \     "texthl": "ALEError",
        \     "signText": "✖",
        \     "signTexthl": "ALEErrorSign",
        \     "virtualTexthl": "Error",
        \ },
        \ 2: {
        \     "name": "Warning",
        \     "texthl": "ALEWarning",
        \     "signText": "⚠",
        \     "signTexthl": "ALEWarningSign",
        \     "virtualTexthl": "Virtual",
        \ },
        \ 3: {
        \     "name": "Information",
        \     "texthl": "ALEInfo",
        \     "signText": "ℹ",
        \     "signTexthl": "ALEInfoSign",
        \     "virtualTexthl": "Virtual",
        \ },
        \ 4: {
        \     "name": "Hint",
        \     "texthl": "ALEInfo",
        \     "signText": "➤",
        \     "signTexthl": "ALEInfoSign",
        \     "virtualTexthl": "Virtual",
        \ },
    \ }

" hi link ALEError Error
hi ALEError term=underline cterm=underline ctermfg=Red gui=undercurl guisp=Red
hi link ALEWarning Warning
hi Virtual cterm=italic ctermfg=10 gui=italic guifg=#4b5558
hi link ALEInfo SpellCap

let $LANGUAGECLIENT_DEBUG=1
let g:LanguageClient_loggingLevel='DEBUG'
let g:LanguageClient_virtualTextPrefix = ''
let g:LanguageClient_loggingFile =  expand('~/LanguageClient.log')
let g:LanguageClient_serverStderr = expand('~/LanguageServer.log')


" neosnippet
" Plugin key-mappings.
" Note: It must be "imap" and "smap".  It uses <Plug> mappings.
" imap <C-k>     <Plug>(neosnippet_expand_or_jump)
" smap <C-k>     <Plug>(neosnippet_expand_or_jump)
" xmap <C-k>     <Plug>(neosnippet_expand_target)

" SuperTab like snippets behavior.
" Note: It must be "imap" and "smap".  It uses <Plug> mappings.
" imap <expr><tab> neosnippet#expandable_or_jumpable() ? "\<Plug>(neosnippet_expand_or_jump)" : pumvisible() ? "\<c-n>" : "\<tab>"
" smap <expr><tab> neosnippet#expandable_or_jumpable() ? "\<Plug>(neosnippet_expand_or_jump)" : "\<tab>"

" For conceal markers.
" if has('conceal')
  " set conceallevel=2 concealcursor=niv
" endif
" Enable snipMate compatibility feature.
" let g:neosnippet#enable_snipmate_compatibility = 1
" let g:neosnippet#snippets_directory='~/.vim/custom-snippets'


" rainbow
let g:rainbow_conf = {
\	'guifgs': ['#DC322F', 'royalblue3', 'darkorange3', 'seagreen3'],
\	'ctermfgs': ['lightred', 'lightblue', 'lightyellow', 'lightcyan', 'lightmagenta'],
\}
let g:rainbow_active = 1


" vim airline
" let g:airline#extensions#tabline#enabled = 1


" deoplete
let g:deoplete#enable_at_startup = 0

" ==== delimitMate ====
let g:delimitMate_matchpairs = "(:),[:],{:}"
let g:delimitMate_expand_cr = 1
let g:delimitMate_expand_space = 1
let g:delimitMate_autoclose = 1


" Solarized stuff
" let g:solarized_termtrans=0
" let g:solarized_degrade=0
" let g:solarized_bold=1
" let g:solarized_underline=1
" let g:solarized_italic=1
" let g:solarized_termcolors=16
" let g:solarized_contrast="normal"
let g:solarized_visibility="high"
" let g:solarized_diffmode="normal"
" let g:solarized_hitrail=0
let g:solarized_menu=1


" youcompleteme
let g:ycm_filetype_blacklist = {
	\ 'notes' : 1,
	\ 'markdown' : 1,
	\ 'text' : 1,
	\ 'java' : 1,
	\}
let g:ycm_confirm_extra_conf = 0
let g:ycm_global_ycm_extra_conf='~/.vim/.ycm_extra_conf.py'
let g:ycm_collect_identifiers_from_tags_files = 1
let g:ycm_seed_identifiers_with_syntax = 0
" let g:ycm_always_populate_location_list = 1
let g:ycm_autoclose_preview_window_after_completion = 1
let g:ycm_key_invoke_completion = '<C-Space>'
let g:ycm_key_list_select_completion = ['<TAB>']
let g:ycm_key_list_previous_completion = ['<S-TAB>']
" nnoremap <F4> :YcmCompleter GoToDefinition<CR>
let g:ycm_server_log_level = 'error'
let g:ycm_semantic_triggers = {'haskell' : ['. ', '$ ']}
let g:ycm_goto_buffer_command = 'horizontal-split'


" commenting
let NERDSpaceDelims=1
let NERDCreateDefaultMappings=0

" haskellmode, needs to load early
let g:haddock_browser='/usr/bin/firefox'
let g:haddock_browser_callformat='%s file://%s >/dev/null 2>&1 &'

" fastfold
let g:fastfold_savehook = 1
let g:fastfold_fold_command_suffixes =  ['x','X','a','A','o','O','c','C']
let g:fastfold_fold_movement_commands = [']z', '[z', 'zj', 'zk']

let g:markdown_folding = 1
let g:tex_fold_enabled = 1
let g:vimsyn_folding = 'af'
let g:xml_syntax_folding = 1
let g:html_syntax_folding = 1
let g:javaScript_fold = 1
let g:sh_fold_enabled= 7
let g:ruby_fold = 1
let g:perl_fold = 1
let g:perl_fold_blocks = 1
let g:r_syntax_folding = 1
let g:rust_fold = 1
let g:haskell_fold = 1

" tagbar
let g:tagbar_map_togglefold = ['za']
let g:tagbar_map_togglecaseinsensitive = 'zi'

" Nerdtree
let g:NERDTreeMapActivateNode = '<CR>'
let g:NERDTreeMapCustomOpen = ''
let g:NERDTreeMapOpenExpl = 'n'
let g:NERDTreeMapJumpNextSibling = ''
" let g:NERDTreeMapOpenSplit = ''
" use NERDTree instead of netrw
autocmd StdinReadPre * let s:std_in=1
autocmd VimEnter * if argc() == 1 && isdirectory(argv()[0]) && !exists("s:std_in") | exe 'NERDTree' argv()[0] | wincmd p | ene | exe 'cd '.argv()[0] | endif

" overwrite nonsense from editorconfig
let g:EditorConfig_max_line_indicator = 'none'
" let g:EditorConfig_preserve_formatoptions = 1

" vim current word
let g:vim_current_word#highlight_current_word = 0
hi default link CurrentWordTwins CursorColumn

" vista
let g:vista#renderer#enable_icon = 0
